--[[
		    ----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----


                              ####    ######        ####     #######      ####    #######    #         ########
                             ##  ##   #     ##    ##    ##   #     ##    ##  ##   #     ##   #         #
                            #      #  #      ##  ##      ##  #       #  #      #  #       #  #         #
                            #      #  #       #  #        #  #     ##   #      #  #     ##   #         #
                            ########  #       #  #        #  #######    ########  #######    #         ########
                            #      #  #       #  #        #  #   #      #      #  #     ##   #         #
                            #      #  #      ##  ##      ##  #    #     #      #  #       #  #         #
                            #      #  #     ##    ##    ##   #     #    #      #  #     ##   #         #
                            #      #  ######        ####     #      #   #      #  #######    ########  ########


                          #      #    ####    #########     ######    #      #  #         #  #       #     ####  
                          #      #   ##  ##       #       ##      ##  #      #  #         #  ##      #   ##    ##
                          #      #  #      #      #      ##           #      #  #         #  # #     #  ##
                          #      #  #      #      #      #            #      #  #         #  #  #    #  #
                          ########  ########      #      #            ########  #         #  #   #   #  #
                          #      #  #      #      #      #            #      #  #         #  #    #  #  #     ###
                          #      #  #      #      #      ##           #      #  #         #  #     # #  ##      #
                          #      #  #      #      #       ##      ##  #      #  #         #  #      ##   ##    ##
                          #      #  #      #      #         ######    #      #  ########  #  #       #     ####  


                                            #       #  ########    ####    #########    ####  
                                            ##      #  #         ##    ##      #      ##    ##
                                            # #     #  #         #             #      #
                                            #  #    #  #         ##            #      ##
                                            #   #   #  ########   ######       #       ######
                                            #    #  #  #               ##      #            ##
                                            #     # #  #                 #     #              #
                                            #      ##  #         ##    ##      #      ##    ##
                                            #       #  ########    ####        #        ####  


		    ----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----


						    ----o----(||)----oo----(||)----o----

							  v3.03 3rd September 2017
						    Copyright (C) Taraezor / Chris Birch

						    ----o----(||)----oo----(||)----o----

]]
--------------------------------------------------------------------------------------------------------------------------------------------

local addonName, L = ...

local textures = { ["1"] = "Interface\\TargetingFrame\\PetBadge-Beast", ["2"] = "Interface\\Store\\Category-icon-pets",
		["3"] = "Interface\\Store\\Category-icon-featured", ["4"] = "Interface\\PlayerFrame\\MonkDarkPower",
		["5"] = "Interface\\PlayerFrame\\MonkLightPower", ["6"] = "Interface\\Common\\Friendship-ManaOrb",
		["7"] = "Interface\\LFGFrame\\BattlenetWorking", ["8"] = "Interface\\HelpFrame\\HelpIcon-CharacterStuck",
		["9"] = "Interface\\PlayerFrame\\UI-PlayerFrame-DeathKnight-Frost", ["10"] = "Interface\\Common\\Indicator-Gray",
		["11"] = "Interface\\Common\\Indicator-Red", ["12"] = "Interface\\Common\\Indicator-Yellow",
		["13"] = "Interface\\Common\\Indicator-Green",
}
local numTextures = 13

local	RavasaurHN1, RavasaurHN2, RavasaurHN3, RavasaurHN4, RavasaurHN5, RazormawHN, TakkLeapingHN1, TakkLeapingHN2, TakkLeapingHN3,
	TakkLeapingHN4, DartingHN1, DartingHN2, DartingHN3, DartingHN4
local Mini, numMini = {}, 5

local cos = math.cos
local find = string.find
local gmatch = string.gmatch
local lower = string.lower
local random = random
local sin = math.sin
local sqrt = math.sqrt
local sub = string.sub

local CalendarGetDate = CalendarGetDate
local GetCurrentMapAreaID = GetCurrentMapAreaID
local GetCurrentMapDungeonLevel = GetCurrentMapDungeonLevel
local GetCVar = GetCVar
local GetItemInfo = GetItemInfo
local GetPlayerFacing = GetPlayerFacing
local GetPlayerMapPosition = GetPlayerMapPosition
local GetSubZoneText = GetSubZoneText
local IsControlKeyDown = IsControlKeyDown
local IsIndoors = IsIndoors
local PlaySoundFile = PlaySoundFile
local PlaySound = PlaySound
local SetMapToCurrentZone = SetMapToCurrentZone
local StopSound = StopSound

--------------------------------------------------------------------------------------------------------------------------------------------
-- Print Colours - Purple theme
--------------------------------------------------------------------------------------------------------------------------------------------

local pc_colour_Prefix		= "\124cFF8258FA"
local pc_colour_Highlight	= "\124cFFB19EFF"
local pc_colour_PlainText	= "\124cFF819FF7"

local function printPC( message )
	DEFAULT_CHAT_FRAME:AddMessage( pc_colour_Prefix.. addonName.. ": ".. pc_colour_PlainText.. message.. "\124r" )
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Event Handling (World Map) & OnUpdate Handler (Mini Map)
--		========================================================
--
--------------------------------------------------------------------------------------------------------------------------------------------

function AHN_WorldMapTooltipOnEnter( self )

	WorldMapTooltip:SetOwner( self, "ANCHOR_CURSOR" )

	mapAreaID = GetCurrentMapAreaID()
	local eggID = 0

	if mapAreaID == 201 then		-- Un'Goro Crater
		WorldMapTooltip:SetText( "\124cFFBF00FF".. L["Ravasaur Matriarch's Nest"] )
		WorldMapTooltip:AddLine( L["Ravasaur Hatchling"] )
		eggID = 48122

	elseif mapAreaID == 141 then		-- Dustwallow Marsh
		WorldMapTooltip:SetText( "\124cFFBF00FF".. L["Dart's Nest"] )
		WorldMapTooltip:AddLine( L["Leaping Hatchling"] )
		eggID = 48118

	elseif mapAreaID == 40 then		-- Wetlands
		WorldMapTooltip:SetText( "\124cFFBF00FF".. L["Razormaw Matriarch's Nest"] )
		WorldMapTooltip:AddLine( L["Razormaw Hatchling"] )
		eggID = 48124

	elseif mapAreaID == 11 then		-- Northern Barrens
		WorldMapTooltip:SetText( "\124cFFBF00FF".. L["Takk's Nest"] )
		WorldMapTooltip:AddLine( L["Darting Hatchling"] )
		eggID = 48112
	end

	if ( AdorableHatchlingNestsDB.showCoordinates == "y" ) then
		WorldMapTooltip:AddLine( "(".. self.x.. ",".. self.y.. ")" )
	end

	WorldMapTooltip:Show()

	if IsControlKeyDown() then
		local activeWindow = ChatEdit_GetActiveWindow()
		if ( activeWindow ) then
			local eggName, eggLink = GetItemInfo( eggID )
			if eggLink and not find( activeWindow:GetText(), eggName ) then
				activeWindow:Insert( eggLink.. " @ (".. self.x.. ",".. self.y.. ")" )
			end
		end
	end
end

function AHN_WorldMapTooltipOnLeave( self )
	WorldMapTooltip:Hide()
end

local function CreateNest( x, y)

	local icon = CreateFrame( "Button", nil, WorldMapButton )			-- overlayFrame also works
	icon:SetPoint( "CENTER", WorldMapButton, "CENTER", x, y )
	icon:HookScript( "OnEnter", AHN_WorldMapTooltipOnEnter )
	icon:HookScript( "OnLeave", AHN_WorldMapTooltipOnLeave )
	local iconTexture = icon:CreateTexture( nil, "OVERLAY" )
	if ( AdorableHatchlingNestsDB.texture == "7" ) then
		iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture].. tostring( random( 8 ) + 16 ) )
	else
		iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture] )
	end
	icon:SetSize( AdorableHatchlingNestsDB.iconSize, AdorableHatchlingNestsDB.iconSize )
	iconTexture:SetAllPoints()
	icon.iconTexture = iconTexture
	icon:Hide()
	return icon
end

local function HideAllAHN()

	RavasaurHN1:Hide()
	RavasaurHN2:Hide()
	RavasaurHN3:Hide()
	RavasaurHN4:Hide()
	RavasaurHN5:Hide()
	RazormawHN:Hide()
	TakkLeapingHN1:Hide()
	TakkLeapingHN2:Hide()
	TakkLeapingHN3:Hide()
	TakkLeapingHN4:Hide()
	DartingHN1:Hide()
	DartingHN2:Hide()
	DartingHN3:Hide()
	DartingHN4:Hide()
end

local function HideAllMinimap()

	for i = 1, numMini do
		Mini[ i ]:SetAlpha( 0 )
	end
end

local function PlayRandomSound()

	local randomNum
	local _, month, today, year = CalendarGetDate()

	if ( AdorableHatchlingNestsDB.sound == "b" ) then
		if ( ( month == 4 ) and ( today == 1 ) ) or ( AdorableHatchlingNestsDB.alwaysAprilFool == "y" ) then
			randomNum = random(10)
			PlaySoundFile(	( (randomNum >= 8) and "Interface\\AddOns\\Adorable_Hatchling_Nests\\Godzilla.mp3" ) or
				( "Sound\\creature\\RAPTORPET\\RaptorPetClickable_0"..tostring(randomNum)..".ogg" ) )
		else
			randomNum = random(7)
			PlaySoundFile("Sound\\creature\\RAPTORPET\\RaptorPetClickable_0"..tostring(randomNum)..".ogg")
		end
	elseif ( AdorableHatchlingNestsDB.sound == "a" ) then
		if ( ( month == 4 ) and ( today == 1 ) ) or ( AdorableHatchlingNestsDB.alwaysAprilFool == "y" ) then
			randomNum = random(20)
			PlaySoundFile(	( (randomNum >= 10) and "Interface\\AddOns\\Adorable_Hatchling_Nests\\Godzilla.mp3" ) or
					( (randomNum >= 7) and "Interface\\AddOns\\Adorable_Hatchling_Nests\\TyrannosaurusRex1.mp3" ) or
					( (randomNum >= 4) and "Interface\\AddOns\\Adorable_Hatchling_Nests\\Velociraptor1.mp3" ) or
					( "Interface\\AddOns\\Adorable_Hatchling_Nests\\Velociraptor2.mp3" ) )
		else
			randomNum = random(20)
			PlaySoundFile(	( (randomNum >= 15) and "Interface\\AddOns\\Adorable_Hatchling_Nests\\TyrannosaurusRex1.mp3" ) or
					( (randomNum >= 8) and "Interface\\AddOns\\Adorable_Hatchling_Nests\\Velociraptor1.mp3" ) or
					( "Interface\\AddOns\\Adorable_Hatchling_Nests\\Velociraptor2.mp3" ) )
		end
	end
end

local mapAreaID = 0
local minimapRadii = { 233 + 1/3, 200, 166 + 2/3, 133 + 1/3, 100, 66 + 2/3 }	-- Units: game yards
local minimapZoom, minimapRadius, posX, posY, minimapWidth, minimapHeight, theta
local allowBlink = true

local function AdjustMinimapCoordinates( x, y, mapAreaID )

	local distX, distY, scaledX, scaledY, stepX, stepY = posX - x / 100, posY - y / 100

	if mapAreaID == 201 then	-- Un'Goro

		scaledX, scaledY = distX * 100 / ( minimapRadius * 0.055 ), distY * 100 / ( minimapRadius * 0.081 )

	elseif mapAreaID == 141 then	-- Dustwallow Marsh

		scaledX, scaledY = distX * 100 / ( minimapRadius * 0.038 ), distY * 100 / ( minimapRadius * 0.057 )

	elseif mapAreaID == 40 then	-- Wetlands

		if ( GetSubZoneText() == L["Raptor Ridge"] ) and IsIndoors() then
			stepX, stepY = ( 0.028 - 0.018 ) / 5, ( 0.042 - 0.027 ) / 5	-- Good results for all zoom levels
			scaledX = distX * 100 / ( minimapRadius * ( 0.028 - stepX * minimapZoom) )
			scaledY = distY * 100 / ( minimapRadius * ( 0.042 - stepY * minimapZoom) )
		else
			scaledX, scaledY = distX * 100 / ( minimapRadius * 0.048 ), distY * 100 / ( minimapRadius * 0.075 )
		end

	else	-- Northern Barrens

		scaledX, scaledY = distX * 100 / ( minimapRadius * 0.035 ), distY * 100 / ( minimapRadius * 0.052 )
	end

	if GetCVar( "rotateMinimap" ) == "1" then
		local cosTheta, sinTheta = cos( GetPlayerFacing() ), sin( GetPlayerFacing() )
		scaledX, scaledY = cosTheta * scaledX - sinTheta * scaledY, sinTheta * scaledX + cosTheta * scaledY
	end

	-- Allow to float on border and not exceed border
	local pointRadiusSquared = scaledX^2 + scaledY^2
	allowBlink = true
	if pointRadiusSquared > 0.175 then
		allowBlink = false
	end
	if pointRadiusSquared > 0.2025 then
		local reductionRatio = 0.45 / sqrt( pointRadiusSquared )
		scaledX, scaledY = scaledX * reductionRatio, scaledY * reductionRatio
	end

	return -scaledX * minimapWidth, scaledY * minimapHeight
end

local function ApplyTextureToMiniMap( i )

	if ( AdorableHatchlingNestsDB.texture == "7" ) and ( allowBlink == true ) then
		if ( Mini[ i ].eyeID >= 19 ) and ( Mini[ i ].eyeID < 20 ) then
			if ( Mini[ i ].blinking == nil ) then
				if ( random( 60 ) == 60 ) then
					Mini[ i ].blinking = 0
					Mini[ i ].direction = 1
				end
			end
		end
		if Mini[ i ].blinking then
			Mini[ i ].blinking = Mini[ i ].blinking + Mini[ i ].direction
			if ( Mini[ i ].blinking > 4 ) then
				Mini[ i ].blinking = 4
				Mini[ i ].direction = -1
			end
			Mini[ i ]:SetTexture( textures[AdorableHatchlingNestsDB.texture].. tostring( Mini[ i ].blinking ) )
			if ( Mini[ i ].blinking == 1 ) and ( Mini[ i ].direction == -1 ) then
				Mini[ i ].blinking = nil
			end
		else
			Mini[ i ].eyeID = Mini[ i ].eyeID + Mini[ i ].eyeSpeed
			if ( Mini[ i ].eyeID >= 25 ) or ( Mini[ i ].eyeID < 17 ) then
				Mini[ i ].eyeSpeed = Mini[ i ].eyeSpeed * -1
				Mini[ i ].eyeID = Mini[ i ].eyeID + Mini[ i ].eyeSpeed
			end
			Mini[ i ]:SetTexture( textures[AdorableHatchlingNestsDB.texture].. tostring( floor( Mini[ i ].eyeID ) ) )
		end
	end
end

local wasInAHNarea, firstTimeIn = true, true

local function DrawOverMiniMap()

	if ( AdorableHatchlingNestsDB.hideIcons == "y" ) or ( WorldMapFrame:IsVisible() and ( GetCurrentMapAreaID() ~= mapAreaID ) ) then
		HideAllMinimap()
		return
	end

	if mapAreaID == 0 then
		SetMapToCurrentZone()
		mapAreaID = GetCurrentMapAreaID()
		wasInAHNarea = false
		if ( firstTimeIn == true ) then
			HideAllMinimap()
			firstTimeIn = false
		end
	end

	local isIndoors = IsIndoors()

	if ( ( mapAreaID == 201 ) and not isIndoors and ( GetCurrentMapDungeonLevel() == 0 ) ) or 
			( ( mapAreaID == 141 ) and not isIndoors ) or
			( ( mapAreaID == 40 ) and ( GetSubZoneText() ~= L["The Great Sea"] ) and
				( ( GetSubZoneText() == L["Raptor Ridge"] ) or not isIndoors ) ) or
			( ( mapAreaID == 11 ) and not isIndoors and ( GetCurrentMapDungeonLevel() == 0 ) ) then

		wasInAHNarea = true
		minimapZoom = Minimap:GetZoom()
		minimapRadius = minimapRadii[ minimapZoom + 1 ]
		posX, posY = GetPlayerMapPosition("player")
		minimapWidth, minimapHeight = Minimap:GetWidth(), Minimap:GetHeight()

		for i = 1, numMini do
			Mini[ i ]:ClearAllPoints()
		end

		if ( posX == 0 ) and ( posY == 0 ) then
			HideAllMinimap()
			wasInAHNarea = false
			return
		end

		if mapAreaID == 201 then		-- Un'Goro Crater

			Mini[1]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( 62.97, 63.08, 201 ) )
			Mini[1].x, Mini[1].y = 62.97, 63.08
			ApplyTextureToMiniMap( 1 )
			Mini[2]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( 62.09, 65.23, 201 ) )
			Mini[2].x, Mini[2].y = 62.09, 65.23
			ApplyTextureToMiniMap( 2 )
			Mini[3]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( 62.06, 73.36, 201 ) )
			Mini[3].x, Mini[3].y = 62.06, 73.36
			ApplyTextureToMiniMap( 3 )
			Mini[4]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( 68.83, 66.79, 201 ) )
			Mini[4].x, Mini[4].y = 68.83, 66.79
			ApplyTextureToMiniMap( 4 )
			Mini[5]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( 68.95, 61.06, 201 ) )
			Mini[5].x, Mini[5].y = 68.95, 61.06
			ApplyTextureToMiniMap( 5 )
			for i = 1, numMini do
				Mini[ i ]:SetAlpha( 1 )
			end

		elseif mapAreaID == 141 then		-- Dustwallow Marsh

			Mini[1]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( 48.01, 14.26, 141 ) )
			Mini[1].x, Mini[1].y = 48.01, 14.26
			ApplyTextureToMiniMap( 1 )
			Mini[2]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( 46.50, 17.15, 141 ) )
			Mini[2].x, Mini[2].y = 46.50, 17.15
			ApplyTextureToMiniMap( 2 )
			Mini[3]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( 47.98, 19.07, 141 ) )
			Mini[3].x, Mini[3].y = 47.98, 19.07
			ApplyTextureToMiniMap( 3 )
			Mini[4]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( 49.17, 17.36, 141 ) )
			Mini[4].x, Mini[4].y = 49.17, 17.36
			ApplyTextureToMiniMap( 4 )
			for i = 1, 4 do
				Mini[ i ]:SetAlpha( 1 )
			end
			Mini[5]:SetAlpha( 0 )

		elseif mapAreaID == 40 then		-- Wetlands

			Mini[1]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( 70.03, 29.15, 40 ) )
			Mini[1].x, Mini[1].y = 70.03, 29.15
			ApplyTextureToMiniMap( 1 )
			Mini[1]:SetAlpha( 1 )
			for i = 2, 5 do
				Mini[ i ]:SetAlpha( 0 )
			end

		elseif mapAreaID == 11 then		-- Northern Barrens

			Mini[1]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( 60.95, 19.76, 11 ) )
			Mini[1].x, Mini[1].y = 60.95, 19.76
			ApplyTextureToMiniMap( 1 )
			Mini[2]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( 62.76, 20.18, 11 ) )
			Mini[2].x, Mini[2].y = 62.76, 20.18
			ApplyTextureToMiniMap( 2 )
			Mini[3]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( 64.17, 23.00, 11 ) )
			Mini[3].x, Mini[3].y = 64.17, 23.00
			ApplyTextureToMiniMap( 3 )
			Mini[4]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( 64.94, 28.60, 11 ) )
			Mini[4].x, Mini[4].y = 64.94, 28.60
			ApplyTextureToMiniMap( 4 )
			for i = 1, 4 do
				Mini[ i ]:SetAlpha( 1 )
			end
			Mini[5]:SetAlpha( 0 )
		end

	elseif ( wasInAHNarea == true ) then
		HideAllMinimap()
		wasInAHNarea = false
	end
end

local prevMapAreaID = 0

local function ShowOnWorldMap()

	if ( AdorableHatchlingNestsDB.hideIcons == "y" ) then

		HideAllAHN()
		prevMapAreaID = 0

	elseif not WorldMapFrame:IsVisible() then

		prevMapAreaID = 0
		return

	elseif GetCurrentMapAreaID() == 201 then	-- Un'Goro Crater

		if ( GetSubZoneText() == L["The Slithering Scar"] ) then
			if ( GetCurrentMapDungeonLevel() ~= 0 ) then
				HideAllAHN()
				return
			end
		end

		RavasaurHN1:Show()
		RavasaurHN2:Show()
		RavasaurHN3:Show()
		RavasaurHN4:Show()
		RavasaurHN5:Show()
		RazormawHN:Hide()
		TakkLeapingHN1:Hide()
		TakkLeapingHN2:Hide()
		TakkLeapingHN3:Hide()
		TakkLeapingHN4:Hide()
		DartingHN1:Hide()
		DartingHN2:Hide()
		DartingHN3:Hide()
		DartingHN4:Hide()
		if ( prevMapAreaID ~= 201 ) then
			PlayRandomSound()
			prevMapAreaID = 201
		end

	elseif GetCurrentMapAreaID() == 141 then	-- Dustwallow Marsh

		RavasaurHN1:Hide()
		RavasaurHN2:Hide()
		RavasaurHN3:Hide()
		RavasaurHN4:Hide()
		RavasaurHN5:Hide()
		RazormawHN:Hide()
		TakkLeapingHN1:Hide()
		TakkLeapingHN2:Hide()
		TakkLeapingHN3:Hide()
		TakkLeapingHN4:Hide()
		DartingHN1:Show()
		DartingHN2:Show()
		DartingHN3:Show()
		DartingHN4:Show()
		if ( prevMapAreaID ~= 141 ) then
			PlayRandomSound()
			prevMapAreaID = 141
		end

	elseif GetCurrentMapAreaID() == 40 then		-- Wetlands

 		RavasaurHN1:Hide()
		RavasaurHN2:Hide()
		RavasaurHN3:Hide()
		RavasaurHN4:Hide()
		RavasaurHN5:Hide()
		RazormawHN:Show()
		TakkLeapingHN1:Hide()
		TakkLeapingHN2:Hide()
		TakkLeapingHN3:Hide()
		TakkLeapingHN4:Hide()
		DartingHN1:Hide()
		DartingHN2:Hide()
		DartingHN3:Hide()
		DartingHN4:Hide()
		if ( prevMapAreaID ~= 40 ) then
			PlayRandomSound()
			prevMapAreaID = 40
		end

	elseif GetCurrentMapAreaID() == 11 then		-- Northern Barrens

		if ( ( GetSubZoneText() == L["Wailing Caverns"] ) or ( GetSubZoneText() == L["Cavern of Mists"] ) ) then
			if ( GetCurrentMapDungeonLevel() ~= 0 ) then
				HideAllAHN()
				return
			end
		end

		RavasaurHN1:Hide()
		RavasaurHN2:Hide()
		RavasaurHN3:Hide()
		RavasaurHN4:Hide()
		RavasaurHN5:Hide()
		RazormawHN:Hide()
		TakkLeapingHN1:Show()
		TakkLeapingHN2:Show()
		TakkLeapingHN3:Show()
		TakkLeapingHN4:Show()
		DartingHN1:Hide()
		DartingHN2:Hide()
		DartingHN3:Hide()
		DartingHN4:Hide()
		if ( prevMapAreaID ~= 11 ) then
			PlayRandomSound()
			prevMapAreaID = 11
		end

	else
		HideAllAHN()
		prevMapAreaID = 0
	end
end

local function WorldMapUpdate( self, event, ...)

	if event == "PLAYER_LOGIN" then
		if not AdorableHatchlingNestsDB then 
			AdorableHatchlingNestsDB			= {}
			AdorableHatchlingNestsDB.iconSize		= 20
			AdorableHatchlingNestsDB.sound			= "b"
			AdorableHatchlingNestsDB.texture		= "7"
			AdorableHatchlingNestsDB.alwaysAprilFool	= "n"
			AdorableHatchlingNestsDB.hideIcons		= "n"
			AdorableHatchlingNestsDB.showCoordinates	= "n"
		else
			local iconSize = AdorableHatchlingNestsDB.iconSize or 20
			local sound = AdorableHatchlingNestsDB.sound or "b"
			local texture = AdorableHatchlingNestsDB.texture or "7"
			local alwaysAprilFool = AdorableHatchlingNestsDB.alwaysAprilFool or "n"
			local hideIcons = AdorableHatchlingNestsDB.hideIcons or "n"
			local showCoordinates = AdorableHatchlingNestsDB.showCoordinates or "n"
			AdorableHatchlingNestsDB = {}
			AdorableHatchlingNestsDB.iconSize = iconSize
			AdorableHatchlingNestsDB.sound = sound
			AdorableHatchlingNestsDB.texture = texture
			AdorableHatchlingNestsDB.alwaysAprilFool = alwaysAprilFool
			AdorableHatchlingNestsDB.hideIcons = hideIcons
			AdorableHatchlingNestsDB.showCoordinates = showCoordinates
		end
		return
	end

	if ( firstTimeIn == true ) then

		if event ~= "PLAYER_ENTERING_WORLD" then return end

 		local mapWidth = WorldMapDetailFrame:GetWidth()
 		local mapHeight = WorldMapDetailFrame:GetHeight()

		local function AdjustCoordinates( x, y )
			return (x - 50) * mapWidth / 100, (mapHeight / 2) - (mapHeight * y / 100)
		end

		-- Ravasaur Hatchling (Un'Goro Crater)	Ravasaur Matriarch nest locations
		RavasaurHN1 = CreateNest( AdjustCoordinates( 62.97, 63.08 ) )
		RavasaurHN1.x, RavasaurHN1.y = 62.97, 63.08
		RavasaurHN2 = CreateNest( AdjustCoordinates( 62.09, 65.23 ) )
		RavasaurHN2.x, RavasaurHN2.y = 62.09, 65.23
		RavasaurHN3 = CreateNest( AdjustCoordinates( 62.06, 73.36 ) )
		RavasaurHN3.x, RavasaurHN3.y = 62.06, 73.36
		RavasaurHN4 = CreateNest( AdjustCoordinates( 68.83, 66.79 ) )
		RavasaurHN4.x, RavasaurHN4.y = 68.83, 66.79
		RavasaurHN5 = CreateNest( AdjustCoordinates( 68.95, 61.06 ) )
		RavasaurHN5.x, RavasaurHN5.y = 68.95, 61.06

		-- Razormaw Hatchling (Wetlands)	The Razormaw Matriarch nest location
		RazormawHN = CreateNest( AdjustCoordinates( 70.03, 29.15 ) )
		RazormawHN.x, RazormawHN.y = 70.03, 29.15

		-- Leaping Hatchling (Northern Barrens)	Takk's Leaping Hatchling nest locations
		TakkLeapingHN1 = CreateNest( AdjustCoordinates( 60.95, 19.76 ) )
		TakkLeapingHN1.x, TakkLeapingHN1.y = 60.95, 19.76
		TakkLeapingHN2 = CreateNest( AdjustCoordinates( 62.76, 20.18 ) )
		TakkLeapingHN2.x, TakkLeapingHN2.y = 62.76, 20.18
		TakkLeapingHN3 = CreateNest( AdjustCoordinates( 64.17, 23.00 ) )
		TakkLeapingHN3.x, TakkLeapingHN3.y = 64.17, 23.00
		TakkLeapingHN4 = CreateNest( AdjustCoordinates( 64.94, 28.60 ) )
		TakkLeapingHN4.x, TakkLeapingHN4.y = 64.94, 28.60

		-- Darting Hatchling (Dustwallow Marsh)	Dart's Darting Hatchling nest locations
		DartingHN1 = CreateNest( AdjustCoordinates( 48.01, 14.26 ) )
		DartingHN1.x, DartingHN1.y = 48.01, 14.26
		DartingHN2 = CreateNest( AdjustCoordinates( 46.50, 17.15 ) )
		DartingHN2.x, DartingHN2.y = 46.50, 17.15
		DartingHN3 = CreateNest( AdjustCoordinates( 47.98, 19.07 ) )
		DartingHN3.x, DartingHN3.y = 47.98, 19.07
		DartingHN4 = CreateNest( AdjustCoordinates( 49.17, 17.36 ) )
		DartingHN4.x, DartingHN4.y = 49.17, 17.36

		-- Minimap icons. Up to five of these needed. Btw, 19 is the game's default mineral node size
		for i = 1, numMini do
			Mini[ i ] = Minimap:CreateTexture( nil, "OVERLAY" )
			Mini[ i ]:SetAlpha( 0 )
			if ( AdorableHatchlingNestsDB.texture == "7" ) then
				Mini[ i ].eyeID = random( 8 ) + 16
				Mini[ i ]:SetTexture( textures[AdorableHatchlingNestsDB.texture].. tostring(  Mini[ i ].eyeID ) )
				Mini[ i ].eyeSpeed = 0.05 * random( 6 ) + 0.1

			else
				Mini[ i ]:SetTexture( textures[AdorableHatchlingNestsDB.texture] )
			end
			Mini[ i ]:SetSize( 15 * ( AdorableHatchlingNestsDB.iconSize / 20 ), 15 * ( AdorableHatchlingNestsDB.iconSize / 20 ) )
			Mini[ i ]:SetAllPoints()
			Mini[ i ].x, Mini[ i ].y = 0, 0
		end

		firstTimeIn = false
	end

	if ( event == "ZONE_CHANGED_NEW_AREA" ) then
		SetMapToCurrentZone()
		mapAreaID = GetCurrentMapAreaID()
	end

	ShowOnWorldMap()
end

local eventFrame = CreateFrame("Frame")
eventFrame:RegisterEvent("MINIMAP_UPDATE_ZOOM")
eventFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
eventFrame:RegisterEvent("WORLD_MAP_UPDATE")
eventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
eventFrame:RegisterEvent("PLAYER_LOGIN")
eventFrame:SetScript("OnEvent", WorldMapUpdate)

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Minimap Tooltips - OnUpdate Handler
--		================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local prevUpdate, tooltipShowing = 0, false

local function OnUpdateHandler( frame, elapsed )

	prevUpdate = prevUpdate + elapsed
	if prevUpdate > 0.05 then
		DrawOverMiniMap()
		prevUpdate = 0
	end

	if WorldMapFrame:IsShown() then
		return
	end

	local wmuRegistry
	wmuRegistry = { GetFramesRegisteredForEvent( "WORLD_MAP_UPDATE" ) }
	for _, frame in ipairs( wmuRegistry ) do
		frame:UnregisterEvent( "WORLD_MAP_UPDATE" )
	end

	SetMapToCurrentZone()
	mapAreaID = GetCurrentMapAreaID()
	local isIndoors = IsIndoors()

	if ( ( mapAreaID == 201 ) and not isIndoors and ( GetCurrentMapDungeonLevel() == 0 ) ) or 
			( ( mapAreaID == 141 ) and not isIndoors ) or
			( ( mapAreaID == 40 ) and ( GetSubZoneText() ~= L["The Great Sea"] ) and
				( ( GetSubZoneText() == L["Raptor Ridge"] ) or not isIndoors ) ) or
			( ( mapAreaID == 11 ) and not isIndoors and ( GetCurrentMapDungeonLevel() == 0 ) ) then

		local mouseOver = false

		if mapAreaID == 201 then		-- Un'Goro Crater
			for i = 1, 5 do
				if ( Mini[ i ]:IsMouseOver(0,0,0,0) == true ) and ( Mini[ i ]:GetAlpha() == 1 ) then
					if ( tooltipShowing == false ) then
						PlayRandomSound()
					end
					GameTooltip:SetOwner( UIParent, "ANCHOR_CURSOR" )
					GameTooltip:SetText( "\124cFFBF00FF".. L["Ravasaur Matriarch's Nest"] )
					GameTooltip:AddLine( L["Ravasaur Hatchling"] )
					if ( AdorableHatchlingNestsDB.showCoordinates == "y" ) then
						GameTooltip:AddLine( "(".. Mini[ i ].x.. ",".. Mini[ i ].y.. ")" )
					end
					GameTooltip:Show()
					mouseOver, tooltipShowing = true, true
					if IsControlKeyDown() then
						local activeWindow = ChatEdit_GetActiveWindow()
						if ( activeWindow ) then
							local eggName, eggLink = GetItemInfo( 48122 )
							if eggLink and not find( activeWindow:GetText(), eggName ) then
								activeWindow:Insert( eggLink.. " @ (".. Mini[ i ].x.. ",".. Mini[ i ].y.. ")" )
							end
						end
					end
					break
				end
			end

		elseif mapAreaID == 141 then		-- Dustwallow Marsh
			for i = 1, 4 do
				if ( Mini[ i ]:IsMouseOver(0,0,0,0) == true ) and ( Mini[ i ]:GetAlpha() == 1 ) then
					if ( tooltipShowing == false ) then
						PlayRandomSound()
					end
					GameTooltip:SetOwner( UIParent, "ANCHOR_CURSOR" )
					GameTooltip:SetText( "\124cFFBF00FF".. L["Dart's Nest"] )
					GameTooltip:AddLine( L["Leaping Hatchling"] )
					if ( AdorableHatchlingNestsDB.showCoordinates == "y" ) then
						GameTooltip:AddLine( "(".. Mini[ i ].x.. ",".. Mini[ i ].y.. ")" )
					end
					GameTooltip:Show()
					mouseOver, tooltipShowing = true, true
					if IsControlKeyDown() then
						local activeWindow = ChatEdit_GetActiveWindow()
						if ( activeWindow ) then
							local eggName, eggLink = GetItemInfo( 48118 )
							if eggLink and not find( activeWindow:GetText(), eggName ) then
								activeWindow:Insert( eggLink.. " @ (".. Mini[ i ].x.. ",".. Mini[ i ].y.. ")" )
							end
						end
					end
					break
				end
			end

		elseif mapAreaID == 40 then		-- Wetlands
			if ( Mini[ 1 ]:IsMouseOver(0,0,0,0) == true ) and ( Mini[ 1 ]:GetAlpha() == 1 ) then
				if ( tooltipShowing == false ) then
					PlayRandomSound()
				end
				GameTooltip:SetOwner( UIParent, "ANCHOR_CURSOR" )
				GameTooltip:SetText( "\124cFFBF00FF".. L["Razormaw Matriarch's Nest"] )
				GameTooltip:AddLine( L["Razormaw Hatchling"] )
				if ( AdorableHatchlingNestsDB.showCoordinates == "y" ) then
					GameTooltip:AddLine( "(".. Mini[ 1 ].x.. ",".. Mini[ 1 ].y.. ")" )
				end
				GameTooltip:Show()
				mouseOver, tooltipShowing = true, true
				if IsControlKeyDown() then
					local activeWindow = ChatEdit_GetActiveWindow()
					if ( activeWindow ) then
						local eggName, eggLink = GetItemInfo( 48124 )
						if eggLink and not find( activeWindow:GetText(), eggName ) then
							activeWindow:Insert( eggLink.. " @ (".. Mini[ 1 ].x.. ",".. Mini[ 1 ].y.. ")" )
						end
					end
				end
			end

		elseif mapAreaID == 11 then		-- Northern Barrens
			for i = 1, 4 do
				if ( Mini[ i ]:IsMouseOver(0,0,0,0) == true ) and ( Mini[ i ]:GetAlpha() == 1 ) then
					if ( tooltipShowing == false ) then
						PlayRandomSound()
					end
					GameTooltip:SetOwner( UIParent, "ANCHOR_CURSOR" )
					GameTooltip:SetText( "\124cFFBF00FF".. L["Takk's Nest"] )
					GameTooltip:AddLine( L["Darting Hatchling"] )
					if ( AdorableHatchlingNestsDB.showCoordinates == "y" ) then
						GameTooltip:AddLine( "(".. Mini[ i ].x.. ",".. Mini[ i ].y.. ")" )
					end
					GameTooltip:Show()
					mouseOver, tooltipShowing = true, true
					if IsControlKeyDown() then
						local activeWindow = ChatEdit_GetActiveWindow()
						if ( activeWindow ) then
							local eggName, eggLink = GetItemInfo( 48112 )
							if eggLink and not find( activeWindow:GetText(), eggName ) then
								activeWindow:Insert( eggLink.. " @ (".. Mini[ i ].x.. ",".. Mini[ i ].y.. ")" )
							end
						end
					end
					break
				end
			end
		end

		if ( mouseOver == false ) and ( tooltipShowing == true ) then
			GameTooltip:Hide()
			tooltipShowing = false
		end

	elseif ( tooltipShowing == true ) then
		GameTooltip:Hide()
		tooltipShowing = false
	end

	assert( wmuRegistry )
	for _, frame in ipairs( wmuRegistry ) do
		frame:RegisterEvent( "WORLD_MAP_UPDATE" )
	end
end

eventFrame:SetScript("OnUpdate", OnUpdateHandler)

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Slash Commands
--		==============
--
--------------------------------------------------------------------------------------------------------------------------------------------

local soundkitHandle = nil

SLASH_AdorableHN1, SLASH_AdorableHN2, SLASH_AdorableHN3, SLASH_AdorableHN4, SLASH_AdorableHN5 = "/ahn", "/ador", "/raptor", "/rapt", "/arn"

SlashCmdList["AdorableHN"] = function( options )

	local secondParm, options1
	for v in gmatch( options, "(%S+)" ) do
		v = lower(v)
		if not options1 then
			options1 = sub( v,1,1 )
		else
			secondParm = sub( v,1,2 )
			break
		end
	end

	if ( options1 == "?" ) or not options1 then
		printPC( pc_colour_Highlight .. L["Commands"].. ":\n"..
			pc_colour_Highlight.. "i n".. pc_colour_PlainText.. " = ".. L["Select icon"].. ": "..
				pc_colour_Prefix.. "1".. pc_colour_PlainText.. " = ".. L["Beast Pet"].. ", "..
				pc_colour_Prefix.. "2".. pc_colour_PlainText.. " = ".. L["Raptor egg"].. ", "..
				pc_colour_Prefix.. "3".. pc_colour_PlainText.. " = ".. L["Stars"].. ", "..
				pc_colour_Prefix.. "4".. pc_colour_PlainText.. " = ".. L["Purple"].. ", "..
				pc_colour_Prefix.. "5".. pc_colour_PlainText.. " = ".. L["Blue"].. ", "..
				pc_colour_Prefix.. "6".. pc_colour_PlainText.. " = ".. L["Mana Orb"].. ", "..
				pc_colour_Prefix.. "7".. pc_colour_PlainText.. " = ".. L["Raptor eye"].. ", "..
				pc_colour_Prefix.. "8".. pc_colour_PlainText.. " = ".. L["Cogwheel"].. ", "..
				pc_colour_Prefix.. "9".. pc_colour_PlainText.. " = ".. L["Frost"].. ", "..
				pc_colour_Prefix.. "10".. pc_colour_PlainText.. " = ".. L["Grey"].. ", "..
				pc_colour_Prefix.. "11".. pc_colour_PlainText.. " = ".. L["Red"].. ", "..
				pc_colour_Prefix.. "12".. pc_colour_PlainText.. " = ".. L["Yellow"].. ", "..
				pc_colour_Prefix.. "13".. pc_colour_PlainText.. " = ".. L["Green"].. "\n"..
			pc_colour_Highlight.. "s n".. pc_colour_PlainText.. " = ".. L["Icon size"].. ". ".. L["10 to 50"].. "\n"..
			pc_colour_Highlight.. "h".. pc_colour_PlainText.. " = ".. L["Show / Hide map icons"].. ". (".. L["Toggle"].. ")\n"..
			pc_colour_Highlight.. "c".. pc_colour_PlainText.. " = ".. L["Show / Hide map coordinates"].. ". (".. L["Toggle"].. ")\n"..
			pc_colour_Highlight.. "b".. pc_colour_PlainText.. " = ".. L["Select sound"].. ". (".. L["Toggle"].. ")\n"..
			pc_colour_Highlight.. "v".. pc_colour_PlainText.. " = ".. L["Show the version number"].. "\n")

	elseif ( options1 == "i" ) then
		local parm = tonumber(secondParm)
		if parm then
			if (parm >= 1) and (parm <= numTextures) then
				AdorableHatchlingNestsDB.texture = secondParm
				if ( AdorableHatchlingNestsDB.texture == "7" ) then
					RavasaurHN1.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture].. tostring( random( 8 ) + 16 ) )
					RavasaurHN2.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture].. tostring( random( 8 ) + 16 ) )
					RavasaurHN3.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture].. tostring( random( 8 ) + 16 ) )
					RavasaurHN4.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture].. tostring( random( 8 ) + 16 ) )
					RavasaurHN5.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture].. tostring( random( 8 ) + 16 ) )
					RazormawHN.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture].. tostring( random( 8 ) + 16 ) )
					TakkLeapingHN1.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture].. tostring( random( 8 ) + 16 ) )
					TakkLeapingHN2.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture].. tostring( random( 8 ) + 16 ) )
					TakkLeapingHN3.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture].. tostring( random( 8 ) + 16 ) )
					TakkLeapingHN4.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture].. tostring( random( 8 ) + 16 ) )
					DartingHN1.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture].. tostring( random( 8 ) + 16 ) )
					DartingHN2.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture].. tostring( random( 8 ) + 16 ) )
					DartingHN3.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture].. tostring( random( 8 ) + 16 ) )
					DartingHN4.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture].. tostring( random( 8 ) + 16 ) )
					for i = 1, numMini do
						if ( AdorableHatchlingNestsDB.texture == "7" ) then
							Mini[ i ].eyeID = random( 8 ) + 16
							Mini[ i ]:SetTexture( textures[AdorableHatchlingNestsDB.texture].. tostring( Mini[ i ].eyeID ) )
							Mini[ i ].eyeSpeed = 0.05 * random( 6 ) + 0.1
						else
							Mini[ i ]:SetTexture( textures[AdorableHatchlingNestsDB.texture] )
						end
					end
				else
					RavasaurHN1.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture] )
					RavasaurHN2.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture] )
					RavasaurHN3.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture] )
					RavasaurHN4.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture] )
					RavasaurHN5.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture] )
					RazormawHN.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture] )
					TakkLeapingHN1.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture] )
					TakkLeapingHN2.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture] )
					TakkLeapingHN3.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture] )
					TakkLeapingHN4.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture] )
					DartingHN1.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture] )
					DartingHN2.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture] )
					DartingHN3.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture] )
					DartingHN4.iconTexture:SetTexture( textures[AdorableHatchlingNestsDB.texture] )
					for i = 1, numMini do
						Mini[ i ]:SetTexture( textures[AdorableHatchlingNestsDB.texture] )
					end
				end
			end
		else
			printPC( "/ahn i ".. AdorableHatchlingNestsDB.texture )
		end

	elseif ( options1 == "s" ) then
		local parm = tonumber(secondParm)
		if parm then
			if (parm >= 10) and (parm <= 50) then
				AdorableHatchlingNestsDB.iconSize = parm
				RavasaurHN1:SetSize( AdorableHatchlingNestsDB.iconSize, AdorableHatchlingNestsDB.iconSize )
				RavasaurHN2:SetSize( AdorableHatchlingNestsDB.iconSize, AdorableHatchlingNestsDB.iconSize )
				RavasaurHN3:SetSize( AdorableHatchlingNestsDB.iconSize, AdorableHatchlingNestsDB.iconSize )
				RavasaurHN4:SetSize( AdorableHatchlingNestsDB.iconSize, AdorableHatchlingNestsDB.iconSize )
				RavasaurHN5:SetSize( AdorableHatchlingNestsDB.iconSize, AdorableHatchlingNestsDB.iconSize )
				RazormawHN:SetSize( AdorableHatchlingNestsDB.iconSize, AdorableHatchlingNestsDB.iconSize )
				TakkLeapingHN1:SetSize( AdorableHatchlingNestsDB.iconSize, AdorableHatchlingNestsDB.iconSize )
				TakkLeapingHN2:SetSize( AdorableHatchlingNestsDB.iconSize, AdorableHatchlingNestsDB.iconSize )
				TakkLeapingHN3:SetSize( AdorableHatchlingNestsDB.iconSize, AdorableHatchlingNestsDB.iconSize )
				TakkLeapingHN4:SetSize( AdorableHatchlingNestsDB.iconSize, AdorableHatchlingNestsDB.iconSize )
				DartingHN1:SetSize( AdorableHatchlingNestsDB.iconSize, AdorableHatchlingNestsDB.iconSize )
				DartingHN2:SetSize( AdorableHatchlingNestsDB.iconSize, AdorableHatchlingNestsDB.iconSize )
				DartingHN3:SetSize( AdorableHatchlingNestsDB.iconSize, AdorableHatchlingNestsDB.iconSize )
				DartingHN4:SetSize( AdorableHatchlingNestsDB.iconSize, AdorableHatchlingNestsDB.iconSize )
				for i = 1, numMini do
					Mini[ i ]:SetSize( 15 * ( AdorableHatchlingNestsDB.iconSize / 20 ), 15 * ( AdorableHatchlingNestsDB.iconSize / 20 ) )
				end
			end
		else
			printPC( "/ahn s ".. AdorableHatchlingNestsDB.iconSize )
		end

	elseif ( options1 == "h" ) then
		if secondParm then
			if ( AdorableHatchlingNestsDB.hideIcons == "y" ) then
				printPC( "/ahn h (".. L["Hide"].. ")" )
			else
				printPC( "/ahn h (".. L["Show"].. ")" )
			end
		else
			AdorableHatchlingNestsDB.hideIcons = ( AdorableHatchlingNestsDB.hideIcons == "y" ) and "n" or "y"
			if ( AdorableHatchlingNestsDB.hideIcons == "y" ) then
				printPC( "(".. L["Hide"].. ")" )
			else
				printPC( "(".. L["Show"].. ")" )
			end
			ShowOnWorldMap()
		end

	elseif ( options1 == "c" ) then
		if secondParm then
			if ( AdorableHatchlingNestsDB.showCoordinates == "y" ) then
				printPC( "/ahn c (".. L["Show"].. ")" )
			else
				printPC( "/ahn c (".. L["Hide"].. ")" )
			end
		else
			AdorableHatchlingNestsDB.showCoordinates = ( AdorableHatchlingNestsDB.showCoordinates == "y" ) and "n" or "y"
			if ( AdorableHatchlingNestsDB.showCoordinates == "y" ) then
				printPC( "(".. L["Show"].. ")" )
			else
				printPC( "(".. L["Hide"].. ")" )
			end
			ShowOnWorldMap()
		end

	elseif ( options1 == "b" ) then
		if secondParm then
			if ( AdorableHatchlingNestsDB.sound == "b" ) then
				printPC( "/ahn b (".. L["Baby"].. ")" )
			elseif ( AdorableHatchlingNestsDB.sound == "a" ) then
				printPC( "/ahn b (".. L["Adult"].. ")" )
			else
				printPC( "/ahn b (".. L["Silent"].. ")" )
			end
		else
			if ( AdorableHatchlingNestsDB.sound == "b" ) then
				AdorableHatchlingNestsDB.sound = "a"
				printPC( "(".. L["Adult"].. ")" )
			elseif ( AdorableHatchlingNestsDB.sound == "a" ) then
				AdorableHatchlingNestsDB.sound = "s"
				printPC( "(".. L["Silent"].. ")" )
			else
				AdorableHatchlingNestsDB.sound = "b"
				printPC( "(".. L["Baby"].. ")" )
			end
			PlayRandomSound()
		end

	elseif ( options1 == "v" ) then
		local version = GetAddOnMetadata( addonName, "Version" )
		printPC( L["Version: "].. pc_colour_Highlight.. version )

	-- Easter Eggs. Enjoy!

	elseif ( options1 == "p" ) then
		PlayRandomSound()

	elseif ( options1 == "a" ) then
		AdorableHatchlingNestsDB.alwaysAprilFool = ( AdorableHatchlingNestsDB.alwaysAprilFool == "y" ) and "n" or "y"

	elseif ( options1 == "g" ) then
		PlaySoundFile( "Interface\\AddOns\\Adorable_Hatchling_Nests\\Godzilla.mp3" )

	elseif ( options1 == "z" ) then
		if ( soundkitHandle ) then
			StopSound( soundkitHandle, 5000 )
			soundkitHandle = nil
		else
			local soundSelection = random( 2 )
			if ( soundSelection == 1 ) then
				_, soundkitHandle = PlaySound( 22161 )		-- Vashj'ir
			else
				_, soundkitHandle = PlaySound( 14893 )		-- Sholazar
			end
		end
	end
end